<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<?php
    $uri = $HTTP_GET_VARS[ "uri"];
    $my_ip = $_SERVER["SERVER_ADDR"];
    $host = getenv ("HTTP_HOST");
    if (!$host)
	$host = "rpmfind.net";
    if ($query) {
        echo "<title>RPM resource $query</title>";
    } else {
        echo "<title>Search the RPM repository on $host</title>";
    }
?>
<meta name="GENERATOR" content="rpm2html 1.6">
</head>
<body bgcolor="#ffffff" text="#000000" onLoad="document.forms[0].query.focus()">
<table border=5 cellspacing=5 cellpadding=5>
<tbody>
<tr>
<td><a href="/linux/RPM/index.html">Index</a></td>
<td><a href="/linux/RPM/Groups.html">index by Group</a></td>
<td><a href="/linux/RPM/Distribs.html">index by Distribution</a></td>
<td><a href="/linux/RPM/Vendors.html">index by Vendor</a></td>
<td><a href="/linux/RPM/ByDate.html">index by creation date</a></td>
<td><a href="/linux/RPM/ByName.html">index by Name</a></td>
<td><a href="http://rpmfind.net/linux/rpm2html/mirrors.html">Mirrors</a></td>
<td><a href="http://rpmfind.net/linux/rpm2html/help.html">Help</a></td>
</tr>
</tbody></table>
<?php
    // We handle only the first argument so far
    $query = ltrim ($query);
    $list = explode (" ", $query);
    $query = $list[0];
    if (! $query) {
        echo "<h1 align='center'>Search the RPM repository on $host</h1>";
    }
    $system = ltrim ($system);
    $list = explode (" ", $system);
    $system = strtolower($list[0]);
    if (($system) && (strlen($system) >= 20))
        $system="";
    $arch = ltrim ($arch);
    $list = explode (" ", $arch);
    $arch = strtolower($list[0]);
    if (($arch) && (strlen($arch) >= 20))
        $arch="";
?>
<p> To find and download ISO 9660 images check
<a href="http://www.rpmfind.net/BitTorrent/">Rpmfind BitTorrent</a>
service.</p>
<p> The search service can find package by either name (<b>apache</b>),
provides(<b>webserver</b>), absolute file names (<b>/usr/bin/apache</b>),
binaries (<b>gprof</b>) or shared libraries (<b>libXm.so.2</b>) in
standard path. It does not support multiple arguments yet...
<p> The System and Arch are optional added filters, for example
System could be "redhat", "redhat-7.2", "mandrake" or "gnome", 
Arch could be "i386" or "src", etc. depending on your system.
<p>
<form action="<?php echo "$PHP_SELF", "?query=", rawurlencode($query) ?>"
      enctype="application/x-www-form-urlencoded" method="GET">
  <input name="query" type="TEXT" size="45" value="<?php echo $query?>">
  <input name=submit type=submit value="Search ...">
  System <input name="system" type="TEXT" size="20" value="<?php echo $system?>">
  Arch <input name="arch" type="TEXT" size="20" value="<?php echo $arch?>">
</form>
<?php
    function query($select, $system, $arch) {
        if ($select) {
	    if (($system) && ($system != "")) {
	        $select="LCASE(Distribs.Name) LIKE '$system%' and $select";
	    }
	    if (($arch) && ($arch != "")) {
	        $select="$select and Packages.Arch='$arch'";
	    }
	    $result = mysql_query ("SELECT Packages.ID,Packages.filename,Packages.Name,Packages.Version,Packages.Release,Packages.Arch,Packages.Summary,Distribs.Name,Distribs.Path,Distribs.color,Distribs.Directory,Distribs.HTML FROM Packages,Distribs WHERE $select and Packages.Dist=Distribs.ID  ORDER BY Packages.Name,ROUND(SUBSTRING_INDEX(RPAD(Packages.Version,16,'.'),'.',1)),ROUND(SUBSTRING_INDEX(SUBSTRING_INDEX(RPAD(Packages.Version,16,'.'),'.',2),'.',-1)),ROUND(SUBSTRING_INDEX(SUBSTRING_INDEX(RPAD(Packages.Version,16,'.'),'.',3),'.',-1)),SUBSTRING(RPAD(Packages.Version,16,'.'),LENGTH(SUBSTRING_INDEX(RPAD(Packages.Version,16,'.'),'.',3))+2),Packages.Release");
	    if ($result) {
		$j = mysql_num_rows($result);
		if ($j == 0) 
		    mysql_free_result($result);
	    }
	}
	return array($result, $j);
    }
    function query_file($file, $system, $arch) {
        if ($file) {
	    $select="Files.Path='$file'";
	    if (($system) && ($system != "")) {
	        $select="LCASE(Distribs.Name) LIKE '$system%' and $select";
	    }
	    if (($arch) && ($arch != "")) {
	        $select="$select and Packages.Arch='$arch'";
	    }
	    $result = mysql_query ("SELECT Packages.ID,Packages.filename,Packages.Name,Packages.Version,Packages.Release,Packages.Arch,Packages.Summary,Distribs.Name,Distribs.Path,Distribs.color,Distribs.Directory,Distribs.HTML FROM Files,Packages,Distribs WHERE $select and Packages.ID=Files.ID and Packages.Dist=Distribs.ID  ORDER BY Packages.Name,ROUND(SUBSTRING_INDEX(RPAD(Packages.Version,16,'.'),'.',1)),ROUND(SUBSTRING_INDEX(SUBSTRING_INDEX(RPAD(Packages.Version,16,'.'),'.',2),'.',-1)),ROUND(SUBSTRING_INDEX(SUBSTRING_INDEX(RPAD(Packages.Version,16,'.'),'.',3),'.',-1)),SUBSTRING(RPAD(Packages.Version,16,'.'),LENGTH(SUBSTRING_INDEX(RPAD(Packages.Version,16,'.'),'.',3))+2),Packages.Release");
	    if ($result) {
		$j = mysql_num_rows($result);
		if ($j == 0)
		    mysql_free_result($result);
	    }
	}
	return array($result, $j, $file);
    }
    function query_provides($resource, $system, $arch) {
        if ($resource) {
	    $select="Provides.Resource='$resource'";
	    if (($system) && ($system != "")) {
	        $select="LCASE(Distribs.Name) LIKE '$system%' and $select";
	    }
	    if (($arch) && ($arch != "")) {
	        $select="$select and Packages.Arch='$arch'";
	    }
	    $result = mysql_query ("SELECT Packages.ID,Packages.filename,Packages.Name,Packages.Version,Packages.Release,Packages.Arch,Packages.Summary,Distribs.Name,Distribs.Path,Distribs.color,Distribs.Directory,Distribs.HTML FROM Provides,Packages,Distribs WHERE $select and Packages.ID=Provides.ID and Packages.Dist=Distribs.ID  ORDER BY Packages.Name,ROUND(SUBSTRING_INDEX(RPAD(Packages.Version,16,'.'),'.',1)),ROUND(SUBSTRING_INDEX(SUBSTRING_INDEX(RPAD(Packages.Version,16,'.'),'.',2),'.',-1)),ROUND(SUBSTRING_INDEX(SUBSTRING_INDEX(RPAD(Packages.Version,16,'.'),'.',3),'.',-1)),SUBSTRING(RPAD(Packages.Version,16,'.'),LENGTH(SUBSTRING_INDEX(RPAD(Packages.Version,16,'.'),'.',3))+2),Packages.Release");
	    if ($result) {
		$j = mysql_num_rows($result);
		if ($j == 0)
		    mysql_free_result($result);
	    }
	}
	return array($result, $j, $file);
    }
    function run_queries($query, $file, $package, $arch, $system) {
	$j = 0;
	if ($package) {
	    list ($result, $j) = query("Packages.Name='$package'",
				       $system, $arch);
	} 
	if (($package) && ($j == 0))  {
	    list ($result, $j) = query("Provides.Resource='$package'",
				       $system, $arch);
	}
	if (($package) && ($j == 0)) {
	    list ($result, $j) = query("Packages.Name LIKE 'lib$package%'",
				       $system, $arch);
	} 
	if (($package) && ($j == 0)) {
	    list ($result, $j) = query("Packages.Name LIKE '$package%'",
				       $system, $arch);
	} 
	if (($package) && ($j == 0)) {
	    list ($result, $j) = query("Provides.Resource LIKE 'lib$package%'",
				       $system, $arch);
	} 
	if (($package) && ($j == 0)) {
	    list ($result, $j) = query("Provides.Resource LIKE '$package%'",
				       $system, $arch);
	} 
	if (($package) && ($j == 0)) {
	    list ($result, $j, $query) = query_provides("$package",
				       $system, $arch);
	} 
	if (($package) && ($j == 0)) {
	    list ($result, $j, $query) = query_file("$package",
				       $system, $arch);
	} 
	if (($package) && ($j == 0))  {
	    list ($result, $j, $query) = query_file("/bin/$package",
				       $system, $arch);
	}
	if (($package) && ($j == 0)) {
	    list ($result, $j, $query) = query_file("/usr/bin/$package",
				       $system, $arch);
	}
	if (($package) && ($j == 0)) {
	    list ($result, $j, $query) = query_file("/sbin/$package",
				       $system, $arch);
	}
	if (($package) && ($j == 0)) {
	    list ($result, $j, $query) = query_file("/usr/sbin/$package",
				       $system, $arch);
	}
	if (($package) && ($j == 0)) {
	    list ($result, $j, $query) = query_file("/opt/sbin/$package",
				       $system, $arch);
	}
	if (($package) && ($j == 0)) {
	    list ($result, $j, $query) = query_file("/usr/X11R6/bin/$package",
				       $system, $arch);
	}
	if (($package) && ($j == 0)) {
	    list ($result, $j, $query) = query_file("/usr/lib/$package",
				       $system, $arch);
	}
	if (($package) && ($j == 0)) {
	    list ($result, $j, $query) = query_file("/lib/$package",
				       $system, $arch);
	}
	if (($package) && ($j == 0)) {
	    list ($result, $j, $query) = query_file("/opt/lib/$package",
				       $system, $arch);
	}
	if (($package) && ($j == 0)) {
	    list ($result, $j, $query) = query_file("/usr/X11R6/lib/$package",
				       $system, $arch);
	}

	if (($file) && ($j == 0)) {
	    list ($result, $j, $query) = query_file("$file",
				       $system, $arch);
	}
	return array($result, $j, $file);
    }

    if (($query) && (strlen($query) <= 50)) {
	if (strstr ($query, '/')) {
	    // Assumes it's a file query
	    $file =str_replace("*", "%", $query);
	} else if (strstr ($query, '-')) {
	    // looks like one gonna have to cut this into
	    // package/version/release/arch strings
	    // TODO
	    $package =str_replace("*", "%", $query);
	} else {
	    $package=str_replace("*", "%", $query);
	}

	$link = mysql_connect ("localhost", "nobody");
	// pconnect was leading to
	// Warning: Unknown command in /serveur/WWW/public/linux/rpm2html/search.php
	// on line 66
	// Could not connect to the database: 
	// $link = mysql_pconnect ("localhost", "nobody");
	if (!$link) {
	    echo "<p> Could not connect to the database: ", mysql_error();
	} else {
	    mysql_select_db("rpmfind", $link);
	    // First print the mirrors
	    $result = mysql_query ("SELECT URL,name FROM Searches WHERE active = 1");
	    if ($result) {
	        $j = mysql_num_rows($result);
		$encquery = rawurlencode($query);
		$encsystem = rawurlencode($system);
		$encarch = rawurlencode($arch);
		if ($j > 0) {
		    printf("<p> %d active mirrors: ", $j);

		    $url = mysql_result($result, 0, 0);
		    $name = mysql_result($result, 0, 1);
		    printf("[<a href='%s?query=%s&system=%s&arch=%s'>%s</a>]\n",
			   $url, $encquery, $encsystem, $encarch, $name);
		    for ($i = 1; $i < $j; $i++) {
			$url = mysql_result($result, $i, 0);
			$name = mysql_result($result, $i, 1);
			printf("[<a href='%s?query=%s&system=%s&arch=%s'>%s</a>]\n",
			       $url, $encquery, $encsystem, $encarch, $name);
		    }
		    printf("</p>");
		}
		mysql_free_result($result);
	    }
			
	    echo "<h1 align='center'>RPM resource $query</h1>";


	    $origquery = $query;
	    $query = str_replace("*", "%", $query);

	    if ($package) {
		$result = mysql_query ("select DISTINCT URL from Packages where Name='$package' and length(URL) > 5 limit 5");
		if ($result) {
		    $j = mysql_num_rows($result);
		    if ($j == 0) {
			mysql_free_result($result);
		    } else {
		        printf(
		  "<h3>Found %d sites for $package</h3>\n", $j);
		        echo "<ul>\n";
			for ($i = $j - 1; $i >= 0; $i--) {
			    $url = mysql_result($result, $i, 0);
			    printf(
		  "<li><a href='%s'>%s</a>", $url, $url);
			}
		        echo "</ul>\n";
		    }
		}
	    } 

            list($result, $j, $file) = run_queries($query, $file, $package,
	                                           $arch, $system);
	    if ((!($result)) && ($arch != '')) {
		list($result, $j, $file) = run_queries($query, $file, $package,
						       '', $system);
	    }
	    if ((!($result)) && ($system != '')) {
		list($result, $j, $file) = run_queries($query, $file, $package,
						       $arch, '');
	    }
	    if ((!($result)) && ($arch != '') && ($system != '')) {
		list($result, $j, $file) = run_queries($query, $file, $package,
						       '', '');
	    }

	    if ($result) {
		if ($j > 0) {
		    printf("<h3 align='center'> Found %d RPM for ", $j);
		    echo "$origquery\n</h3>";

		    printf("<table><tbody>\n");
		    printf("<tr><td>Package</td><td>Summary</td><td>Distribution</td><td>Download</td></tr>\n");

		    $prevname="";
		    for ($i = $j - 1; $i >= 0; $i--) {
			$path = mysql_result($result, $i, 1);
			$name = mysql_result($result, $i, 2);
			$version = mysql_result($result, $i, 3);
			$release = mysql_result($result, $i, 4);
			$arch = mysql_result($result, $i, 5);
			$summary = mysql_result($result, $i, 6);
			$dist = mysql_result($result, $i, 7);
			$subdir = mysql_result($result, $i, 8);
			$color = mysql_result($result, $i, 9);
			$directory = mysql_result($result, $i, 10);
			$html = mysql_result($result, $i, 11);

                        if ($prevname != $name) {
			    if ($prevname != "")
				echo "</tbody></table> <br> <table><tbody>";
			    $prevname = $name;
			}

			echo "<tr bgcolor='$color'>";
			if (($subdir) && ($directory) && (!$html)) {
			    $rpmsubdir = substr($path, strlen($directory));
			    $pos = strpos($rpmsubdir, "$name-$version-$release");
			    if ($pos == false) {
			        $pos = strpos($rpmsubdir, "$name");
			    }
			    if ($pos == false) {
			        echo "<td></td>";
	                    } else {
				$rpmsubdir = substr($rpmsubdir, 0, $pos);
				$url = "/linux/RPM/$subdir/$rpmsubdir/$name-$version-$release.$arch.html";
				$url = str_replace('///', '/', $url);
				$url = str_replace('//', '/', $url);
				echo "<td><a href='http://$host/$url'>$name-$version-$release.$arch.html</a></td>";
			    }
			} else {
			    echo "<td></td>";
			}
			echo "<td>$summary</td>";
			echo "<td>$dist</td>";
			$url = strstr($path, '/linux');
			if (!$url)
			    $url = strstr($path, '/pub');

			if ($url) {
			    $url = str_replace('///', '/', $url);
			    $url = str_replace('//', '/', $url);
			    if ($host == "rpmfind.net") {
				echo "<td><a href='ftp://rpmfind.net$url'>$name-$version-$release.$arch.rpm</a></td>";
			    } else if ($host == "www.rpmfind.net") {
				echo "<td><a href='ftp://$my_ip$url'>$name-$version-$release.$arch.rpm</a></td>";
			    } else {
				echo "<td><a href='ftp://$host$url'>$name-$version-$release.$arch.rpm</a></td>";
			    }
			} else
			    echo "<td>$name-$version-$release.$arch.rpm</td>";
			echo "</tr>";
		    }

		    printf("</tbody></table>\n");
		    mysql_free_result($result);
		} else {
		    echo "<p> No package found of name $origquery\n";
		}
	    }
	    $result = mysql_query ("SELECT ID,Count,Results FROM Queries WHERE Value='$origquery'");
	    if ($result) {
		$i = mysql_num_rows($result);
		if ($i == 0) {
		    mysql_free_result($result);
		    
		    mysql_query ("INSERT INTO Queries (Value,Count,Results) VALUES ('$origquery',1,$j)");
		} else {
		    $id = mysql_result($result, 0, 0);
		    $count = mysql_result($result, 0, 1);
		    $results = mysql_result($result, 0, 2);
		    $count ++;
		    $results += $j;
		    mysql_query ("UPDATE Queries SET Count=$count,Results=$results WHERE ID=$id");
		}
	    }
	    mysql_close($link);
	}
    }
?>
<hr>
<p>Generated by <a href="http://rpmfind.net/linux/rpm2html/">rpm2html 1.6</a>
<p><a href="mailto:daniel@veillard.com">Daniel Veillard</a>

</body>
</html>

